﻿#include "HMG.CH"

FUNCTION main()

SET DATE BRIT
SET CENTURY ON

DEFINE WINDOW testunzip MAIN AT 0,0 WIDTH 200 HEIGHT 200
       DEFINE DATEPICKER datepicker_1
	           ROW 20
			   COL 20
			   WIDTH 100
			   HEIGHT 20
			   ONLOSTFOCUS getDay()
	   END DATEPICKER

       DEFINE BUTTON Button_1
          ROW 100
          COL 20
          WIDTH 100
          HEIGHT 30
          CAPTION "Download" 
		  ACTION Download()
      END BUTTON	

      DEFINE LABEL Lbl_1
         ROW 45
         COL 20
         WIDTH 150
         HEIGHT 20
		 VALUE ""
      END LABEL		 
	  
	  
END WINDOW
testunzip.center
testunzip.activate
RETURN nil	  


FUNCTION Download()
LOCAL cBhavFile, cFileNm, cUrl, cFile, dDate
      dDate := testunzip.datepicker_1.value
      cBhavFile := 'cm' + ntoc( DAY( dDate ), 10, 2, '0' ) + UPPER( LEFT( CMONTH( dDate ), 3 ) ) + ntoc( YEAR( dDate ), 10, 4, '0' ) + 'bhav.csv'
      cFileNm := cBhavFile + '.zip'
      cUrl := 'https://www1.nseindia.com/content/historical/EQUITIES/' + ntoc( YEAR( dDate ), 10, 4, 0 ) + '/' + UPPER( LEFT( CMONTH( dDate ), 3 ) ) + '/' + cFileNm
      //msgdebug(cUrl)
      cFile := getcurrentfolder() + '\' + cFileNm
      lGotFile := downloadfile( cUrl, cFile, dDate, "NSE" )
      IF !lGotFile
         msginfo( {"NSE Bhavcopy file not found for ", dDate })
         
      ELSE
         IF FILE( cFile )
         
		 UNCOMPRESS cFile
		 msgdebug("File uncompressed")
         
		 ENDIF
     ENDIF
RETURN nil

FUNCTION GetDay()
testUnZip.Lbl_1.value := cdow(testUnZip.datepicker_1.value)
RETURN nil

FUNCTION DownloadFile( cUrl, cFile, dDate, cExchange )

LOCAL oSoap, aRetorno, nHandle, nCont, lOk
LOCAL nFileSize


   lOk := .f.
   nFileSize := 0
   BEGIN SEQUENCE WITH { | e | BREAK( e ) }
      oSoap := Win_OleCreateObject( "MSXML2.ServerXMLHTTP" )
      oSoap:Open( "GET", cUrl, .T. /* asynchronous */ )
      oSoap:Send()

      //check the transmission to see if it has finished
      DO WHILE oSoap:readystate < 4
         DO Events
         IF oSoap:readystate >= 2 .AND. nFileSize = 0
            nFileSize := VAL( oSoap:getResponseHeader( "Content-Length" ) )
         ENDIF
      ENDDO


      IF oSoap:status <> 200
         BREAK "HTTP Server status is " + hb_NToS( oSoap:status ) + " " + oSoap:statusText
      ENDIF
      aRetorno := oSoap:responseBody
   
   RECOVER USING oError
      MsgStop( IF( VALTYPE( oError ) = 'O', oError:Description, oError ) )

   END SEQUENCE

   oSoap := Nil
   IF EMPTY( aRetorno ) .OR. '!DOCTYPE' $ aRetorno
      //msgstop( "file not found on the server" )
      //BREAK
      RETURN lOk
   ENDIF
 
   nHandle := FCREATE( cFile )
   IF VALTYPE( aRetorno ) == "C"
      FWRITE( nHandle, aRetorno )
   ELSE
      FOR nCont = 1 TO LEN( aRetorno )
         FWRITE( nHandle, CHR( aRetorno[ nCont ] ) )
      NEXT
   ENDIF
   FCLOSE( nHandle )

   lOk := FILE( cFile )

RETURN lOk

	 
         
	  
	  